//-----------------------------------------------------------------------
// Copyright (c) 2017 Snap Inc.
//-----------------------------------------------------------------------
#ifdef SC_TEXTURE_EXTERNAL
#extension GL_OES_EGL_image_external : require
#endif
#include <required.glsl>

#ifdef SC_TEXTURE_EXTERNAL
uniform samplerExternalOES screenTexture;
#else
uniform sampler2D screenTexture;
#endif
uniform mat3 screenTextureTransform;

varying vec2 varTex0;

#ifdef VERTEX_SHADER
attribute vec2 position;
attribute vec2 texture0;

void main(void) {
    varTex0 = vec2(screenTextureTransform * vec3(texture0, 1.0));
    gl_Position = vec4(position, 0.0, 1.0);
}
#endif

#ifdef FRAGMENT_SHADER
void main(void) {
#ifdef SWAP_R_B_CHANNELS
    gl_FragColor = texture2D(screenTexture, varTex0).bgra;
#elif defined(GRAYSCALE_AS_ALPHA)
    gl_FragColor = vec4(1, 1, 1, texture2D(screenTexture, varTex0).r);
#else
    gl_FragColor = texture2D(screenTexture, varTex0);
#endif
}
#endif
