"use strict";var __extends=this&&this.__extends||function(){var a=function(e,t){a=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(e,t){e.__proto__=t}||function(e,t){for(var r in t)if(t.hasOwnProperty(r))e[r]=t[r]};return a(e,t)};return function(e,t){a(e,t);function r(){this.constructor=e}e.prototype=t===null?Object.create(t):(r.prototype=t.prototype,new r)}}();Object.defineProperty(exports,"__esModule",{value:true});var AlertUtils=require("../../../common/src/util/AlertUtils");var Composer_1=require("Composer");var Context_1=require("./Context");var Device=require("Device");var fakeData_1=require("./fakeData");var NumberUtils_1=require("../../../common/src/util/NumberUtils");var proto_1=require("../proto");var Strings_1=require("../Strings");function setBusinessProfile(e,t){var r=Context_1.default.get();if(r.actions&&r.actions.setBusinessProfile){r.actions.setBusinessProfile({isManaged:t,businessProfileAndUserData:proto_1.impala.BusinessProfileAndUserData.encode(e)})}}exports.setBusinessProfile=setBusinessProfile;function roleNameForRoleType(e){switch(e){case"business_account_manager":return Strings_1.default.roleAdmin();case"business_account_collaborator":return Strings_1.default.roleCollaborator();case"business_account_story_contributor":return Strings_1.default.roleStoryContributor();case"business_account_moderated_story_contributor":return Strings_1.default.roleModeratedStoryContributor();case"business_account_data_analyst":return Strings_1.default.roleInsightsViewer()}return""}exports.roleNameForRoleType=roleNameForRoleType;exports.SORTED_ROLE_TYPES=["business_account_manager","business_account_collaborator","business_account_story_contributor","business_account_moderated_story_contributor","business_account_data_analyst"];var categories=[{value:"CATEGORY_V3_PEOPLE",title:Strings_1.default.categoryV3People()},{value:"CATEGORY_V3_BUSINESS_GROUP",title:Strings_1.default.categoryV3BusinessGroup()},{value:"CATEGORY_V3_PRODUCT_BRAND",title:Strings_1.default.categoryV3ProductBrand()}];function getBusinessCategories(){return categories}exports.getBusinessCategories=getBusinessCategories;var subcategories={CATEGORY_V3_BUSINESS_GROUP:[{value:"SUBCATEGORY_V3_BUSINESS",title:Strings_1.default.subcategoryV3Business()},{value:"SUBCATEGORY_V3_CHARITY_CAUSE",title:Strings_1.default.subcategoryV3CharityCause()},{value:"SUBCATEGORY_V3_COLLEGE_UNIVERSITY",title:Strings_1.default.subcategoryV3CollegeUniversity()},{value:"SUBCATEGORY_V3_COMMUNITY_ORG",title:Strings_1.default.subcategoryV3CommunityOrg()},{value:"SUBCATEGORY_V3_COMPANY_ENTERPRISE",title:Strings_1.default.subcategoryV3CompanyEnterprise()},{value:"SUBCATEGORY_V3_GOVERNMENT_ORG",title:Strings_1.default.subcategoryV3GovernmentOrg()},{value:"SUBCATEGORY_V3_GROUP",title:Strings_1.default.subcategoryV3Group()},{value:"SUBCATEGORY_V3_INTERNET_COMPANY",title:Strings_1.default.subcategoryV3InternetCompany()},{value:"SUBCATEGORY_V3_MEDIA_NEWS_COMPANY",title:Strings_1.default.subcategoryV3MediaNewsCompany()},{value:"SUBCATEGORY_V3_NONPROFIT_ORG",title:Strings_1.default.subcategoryV3NonprofitOrg()},{value:"SUBCATEGORY_V3_POLITICAL_ORG",title:Strings_1.default.subcategoryV3PoliticalOrg()},{value:"SUBCATEGORY_V3_RELIGIOUS_ORG",title:Strings_1.default.subcategoryV3ReligiousOrg()},{value:"SUBCATEGORY_V3_RESTAURANT_CHAIN",title:Strings_1.default.subcategoryV3RestaurantChain()},{value:"SUBCATEGORY_V3_RETAIL_COMPANY",title:Strings_1.default.subcategoryV3RetailCompany()},{value:"SUBCATEGORY_V3_SPORTS_LEAGUE",title:Strings_1.default.subcategoryV3SportsLeague()},{value:"SUBCATEGORY_V3_SPORTS_TEAM",title:Strings_1.default.subcategoryV3SportsTeam()}].sort(function(e,t){return e.title.localeCompare(t.title)}),CATEGORY_V3_PEOPLE:[{value:"SUBCATEGORY_V3_ACTOR",title:Strings_1.default.subcategoryV3Actor()},{value:"SUBCATEGORY_V3_ARTIST",title:Strings_1.default.subcategoryV3Artist()},{value:"SUBCATEGORY_V3_ATHLETE",title:Strings_1.default.subcategoryV3Athlete()},{value:"SUBCATEGORY_V3_COACH",title:Strings_1.default.subcategoryV3Coach()},{value:"SUBCATEGORY_V3_COMEDIAN",title:Strings_1.default.subcategoryV3Comedian()},{value:"SUBCATEGORY_V3_CREATOR",title:Strings_1.default.subcategoryV3Creator()},{value:"SUBCATEGORY_V3_DANCER",title:Strings_1.default.subcategoryV3Dancer()},{value:"SUBCATEGORY_V3_ENTREPRENEUR",title:Strings_1.default.subcategoryV3Entrepreneur()},{value:"SUBCATEGORY_V3_FASHION_MODEL",title:Strings_1.default.subcategoryV3FashionModel()},{value:"SUBCATEGORY_V3_FILM_DIRECTOR",title:Strings_1.default.subcategoryV3FilmDirector()},{value:"SUBCATEGORY_V3_FILM_TV_PERSONALITY",title:Strings_1.default.subcategoryV3FilmTvPersonality()},{value:"SUBCATEGORY_V3_FITNESS_PRO",title:Strings_1.default.subcategoryV3FitnessPro()},{value:"SUBCATEGORY_V3_FOOD_PRO",title:Strings_1.default.subcategoryV3FoodPro()},{value:"SUBCATEGORY_V3_GOVERNMENT_OFFICIAL",title:Strings_1.default.subcategoryV3GovernmentOfficial()},{value:"SUBCATEGORY_V3_JOURNALIST",title:Strings_1.default.subcategoryV3Journalist()},{value:"SUBCATEGORY_V3_LENS_CREATOR",title:Strings_1.default.subcategoryV3LensCreator()},{value:"SUBCATEGORY_V3_LIFESTYLE_INFLUENCER",title:Strings_1.default.subcategoryV3LifestyleInfluencer()},{value:"SUBCATEGORY_V3_MOTIVATIONAL_SPEAKER",title:Strings_1.default.subcategoryV3MotivationalSpeaker()},{value:"SUBCATEGORY_V3_MOVIE_CHARACTER",title:Strings_1.default.subcategoryV3MovieCharacter()},{value:"SUBCATEGORY_V3_MUSICIAN_BAND",title:Strings_1.default.subcategoryV3MusicianBand()},{value:"SUBCATEGORY_V3_NEWS_PERSONALITY",title:Strings_1.default.subcategoryV3NewsPersonality()},{value:"SUBCATEGORY_V3_PERSON",title:Strings_1.default.subcategoryV3Person()},{value:"SUBCATEGORY_V3_PHOTOGRAPHER",title:Strings_1.default.subcategoryV3Photographer()},{value:"SUBCATEGORY_V3_POLITICAL_CANDIDATE",title:Strings_1.default.subcategoryV3PoliticalCandidate()},{value:"SUBCATEGORY_V3_POLITICIAN",title:Strings_1.default.subcategoryV3Politician()},{value:"SUBCATEGORY_V3_PRODUCER",title:Strings_1.default.subcategoryV3Producer()},{value:"SUBCATEGORY_V3_PROFESSIONAL_GAMER",title:Strings_1.default.subcategoryV3ProfessionalGamer()},{value:"SUBCATEGORY_V3_PUBLIC_FIGURE",title:Strings_1.default.subcategoryV3PublicFigure()},{value:"SUBCATEGORY_V3_SCIENTIST",title:Strings_1.default.subcategoryV3Scientist()},{value:"SUBCATEGORY_V3_SPORTS_PERSONALITY",title:Strings_1.default.subcategoryV3SportsPersonality()},{value:"SUBCATEGORY_V3_TRAVELER",title:Strings_1.default.subcategoryV3Traveler()},{value:"SUBCATEGORY_V3_VLOGGER_BLOGGER",title:Strings_1.default.subcategoryV3VloggerBlogger()},{value:"SUBCATEGORY_V3_VIDEO_GAME_CREATOR",title:Strings_1.default.subcategoryV3VideoGameCreator()},{value:"SUBCATEGORY_V3_WRITER",title:Strings_1.default.subcategoryV3Writer()}].sort(function(e,t){return e.title.localeCompare(t.title)}),CATEGORY_V3_PRODUCT_BRAND:[{value:"SUBCATEGORY_V3_APPAREL_FASHION",title:Strings_1.default.subcategoryV3ApparelFashion()},{value:"SUBCATEGORY_V3_BRAND",title:Strings_1.default.subcategoryV3Brand()},{value:"SUBCATEGORY_V3_FILM_TV",title:Strings_1.default.subcategoryV3FilmTv()},{value:"SUBCATEGORY_V3_HEALTH_BEAUTY",title:Strings_1.default.subcategoryV3HealthBeauty()},{value:"SUBCATEGORY_V3_PRODUCT",title:Strings_1.default.subcategoryV3Product()},{value:"SUBCATEGORY_V3_PUBLISHER",title:Strings_1.default.subcategoryV3Publisher()},{value:"SUBCATEGORY_V3_SERVICE",title:Strings_1.default.subcategoryV3Service()},{value:"SUBCATEGORY_V3_SHOW",title:Strings_1.default.subcategoryV3Show()},{value:"SUBCATEGORY_V3_VIDEO_GAME",title:Strings_1.default.subcategoryV3VideoGame()}].sort(function(e,t){return e.title.localeCompare(t.title)})};function getBusinessSubcategories(){return subcategories}exports.getBusinessSubcategories=getBusinessSubcategories;var emailRegex=/^(([^<>()\[\]\\.,;:\s@"]+(\.[^<>()\[\]\\.,;:\s@"]+)*)|(".+"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,}))$/;function isValidEmail(e){if(!e){return false}return emailRegex.test(e.trim())}exports.isValidEmail=isValidEmail;function getBusinessCategoryDisplayName(e){var t=getBusinessCategories();var r=t.map(function(e){return e.value}).indexOf(e);if(r===-1){return null}return t[r].title}exports.getBusinessCategoryDisplayName=getBusinessCategoryDisplayName;function getBusinessSubcategoryDisplayName(e,t){var r=getBusinessSubcategories()[e];if(!r){return null}var a=r.map(function(e){return e.value}).indexOf(t);if(a===-1){return null}return r[a].title}exports.getBusinessSubcategoryDisplayName=getBusinessSubcategoryDisplayName;function toDisplayAddress(e){if(e){return[e.streetAddress,e.city,e.administrativeDistrict,e.zipCode,e.country].filter(function(e){return e&&!!e.trim()}).join(", ")}return null}exports.toDisplayAddress=toDisplayAddress;function camel(e){var t=e.replace(/'/g,"").split(/[^a-zA-Z]/);return t.map(function(e,t){var r=e.toLowerCase();if(t===-0){return r}return r.charAt(0).toUpperCase()+r.substring(1)}).join("")}exports.camel=camel;function debounce(i,s,o){if(o===void 0){o=false}var n;return function(){var e=this;var t=arguments;var r=function(){n=null;if(!o)i.apply(e,t)};var a=o&&!n;if(n){clearTimeout(n)}n=setTimeout(r,s);if(a)i.apply(e,t)}}exports.debounce=debounce;function websiteToLink(e){var t=e.substring(0,e.indexOf(":"));if(t!=="http"&&t!=="https"&&t!=="tel"&&t!=="mailto"){e="http://"+e}return e}exports.websiteToLink=websiteToLink;function toShortNumber(e,t,r){if(t===void 0){t=false}if(r===void 0){r=false}var a=r?e>0?"+":"-":"";var i=e;i=Math.abs(i);var s=t?Math.round(i/1e8)/10:Math.round(i/1e8);if(s>=1){return Strings_1.default.billions(s)}var o=t?Math.round(i/1e5)/10:Math.round(i/1e6);if(o>=1){return Strings_1.default.millions(o)}var n=t?Math.round(i/100)/10:Math.round(i/1e3);if(n>=1){return Strings_1.default.thousands(n)}i=Math.round(i*10)/10;return NumberUtils_1.formatNumber(i)}exports.toShortNumber=toShortNumber;exports.MetricsFilterActions=[{id:1,title:Strings_1.default.audienceReach()},{id:2,title:Strings_1.default.storyViews()},{id:4,title:Strings_1.default.avgCompletionPct()},{id:3,title:Strings_1.default.avgViewTime()}];var ImpalaViewControllerComponent=function(r){__extends(e,r);function e(){var e=r!==null&&r.apply(this,arguments)||this;e.deviceInsetObserver=null;e.observerCancel=null;e.shouldAdjustContainerPaddingForNavHeader=true;return e}e.prototype.onCreate=function(){var t=this;r.prototype.onCreate.call(this);var e=Context_1.default.get().actions;if(e&&e.observeBusinessProfile){e.observeBusinessProfile(function(e){try{t.viewModel.businessProfileAndUserDataBytes=e}catch(e){console.error("Error parsing profile bytes: "+e)}},function(e){t.observerCancel=e})}this.deviceInsetObserver=Device.observeDisplayInsetChange(function(){t.onDisplayInsetsChanged();t.render()});this.onViewModelUpdated()};e.prototype.onDestroy=function(){r.prototype.onDestroy.call(this);if(this.observerCancel){this.observerCancel()}if(this.deviceInsetObserver){this.deviceInsetObserver.cancel()}};e.prototype.onDisplayInsetsChanged=function(){};e.prototype.onLayout=function(){this.render()};e.prototype.onViewModelUpdated=function(){if(!this.viewModel){return}var e;var t=this.viewModel,r=t.businessProfileAndUserDataBytes,a=t.debugId;if(a){var i=fakeData_1.getFakeAccountData(a);if(i!=null){e=i.businessProfileAndUserData}}if(r){try{e=proto_1.impala.BusinessProfileAndUserData.decode(r)}catch(e){console.error("Error parsing profile bytes: "+e);return}}this.applyBusinessProfileAndUserData(e)};e.prototype.applyBusinessProfileAndUserData=function(e){if(!e){return}var t=e.businessProfile;var r=e.userData;this.setState({profile:t,userData:r})};e.prototype.render=function(){this.setPadding();r.prototype.render.call(this)};e.prototype.setPadding=function(){var e=this.elements.navHeader;if(e){e.attributes.paddingTop=Device.getDisplayTopInset()}var t=this.elements.container;if(t){t.attributes.paddingLeft=Device.getDisplayLeftInset();t.attributes.paddingRight=Device.getDisplayRightInset();if(e&&this.shouldAdjustContainerPaddingForNavHeader){this.getElementFrames(["navHeader"],function(e){if(e.length>0&&e[0]){t.attributes.paddingTop=e[0].height}})}}var r=this.elements.header;if(r){r.attributes.paddingTop=5+Device.getDisplayTopInset()}};e.prototype.showError=function(e){var t=this;AlertUtils.displayAlertIfAvailable({title:e,buttonText:Strings_1.default.okay(),cancelButtonText:Strings_1.default.cancel(),swipeToDismiss:true,style:"default"}).then(function(e){t.setState({showSpinner:false})})};return e}(Composer_1.ViewControllerComponent);exports.ImpalaViewControllerComponent=ImpalaViewControllerComponent;
