"use strict";Object.defineProperty(exports,"__esModule",{value:true});var fakeData_1=require("./fakeData");var proto_1=require("../proto");var RequestUtils=require("../../../common/src/util/RequestUtils");var SIMULATED_DELAY_MS=500;var Service=function(){function e(e){this.config=e||{accountServiceUrl:"",insightsServiceUrl:"",storyServiceUrl:""}}e.prototype.acceptRoleInvite=function(e,t){if(fakeData_1.isFakeAccountId(e)){return new Promise(function(e){return setTimeout(e,SIMULATED_DELAY_MS)}).then(function(){return{}})}var n=proto_1.impala.AcceptRoleInviteRequest.encode({businessId:e,roleType:t});return this.makeRequest(this.config.accountServiceUrl+"/rpc/acceptRoleInvite",n).then(function(e){return proto_1.impala.AcceptRoleInviteResponse.decode(e)})};e.prototype.deactivateBusiness=function(e){if(fakeData_1.isFakeAccountId(e)){return new Promise(function(e){return setTimeout(e,SIMULATED_DELAY_MS)}).then(function(){return{}})}var t=proto_1.impala.DeactivateBusinessRequest.encode({businessId:e});return this.makeRequest(this.config.accountServiceUrl+"/rpc/deactivateBusiness",t).then(function(e){return proto_1.impala.DeactivateBusinessResponse.decode(e)})};e.prototype.deleteRole=function(e,t,n){if(fakeData_1.isFakeAccountId(e)){return new Promise(function(e){return setTimeout(e,SIMULATED_DELAY_MS)}).then(function(){return{}})}var s=proto_1.impala.DeleteRoleRequest.encode({businessId:e,userId:t,roleId:n});return this.makeRequest(this.config.accountServiceUrl+"/rpc/deleteRole",s).then(function(e){return proto_1.impala.DeleteRoleResponse.decode(e)})};e.prototype.deleteRoleInvite=function(e,t){if(fakeData_1.isFakeAccountId(e)){return new Promise(function(e){return setTimeout(e,SIMULATED_DELAY_MS)}).then(function(){return{}})}var n=proto_1.impala.DeleteRoleInviteRequest.encode({businessId:e,inviteeUserId:t});return this.makeRequest(this.config.accountServiceUrl+"/rpc/deleteRoleInvite",n).then(function(e){return proto_1.impala.DeleteRoleInviteResponse.decode(e)})};e.prototype.getAccountInsights=function(e){if(e===void 0){e=""}var t=proto_1.impala.insights.GetInsightsSummaryRequest.encode({businessId:e});return this.makeRequest(this.config.insightsServiceUrl+"/insights/rpc/getAccountInsights",t).then(function(e){return proto_1.impala.insights.GetInsightsSummaryResponse.decode(e)})};e.prototype.getBusinessProfile=function(t){if(fakeData_1.isFakeAccountId(t)){return new Promise(function(e){return setTimeout(e,SIMULATED_DELAY_MS)}).then(function(){var e=fakeData_1.getFakeAccountData(t);if(!e){throw new Error("No account data")}return e.businessProfileAndUserData})}var e=proto_1.impala.GetBusinessProfileRequest.encode({id:t});return this.makeRequest(this.config.accountServiceUrl+"/rpc/getBusinessProfile",e).then(function(e){var t=proto_1.impala.GetBusinessProfileResponse.decode(e).profile;if(!t){throw new Error("No profile")}return t})};e.prototype.getInsightsStories=function(e,t,n){if(e===void 0){e=""}if(t===void 0){t=""}if(n===void 0){n=28}var s=proto_1.impala.insights.GetStoriesInsightsRequest.encode({businessId:e,pageId:t,limit:n});return this.makeRequest(this.config.insightsServiceUrl+"/insights/rpc/getStoriesInsights",s).then(function(e){return proto_1.impala.insights.GetStoriesInsightsResponse.decode(e)})};e.prototype.getProfileCallouts=function(t,e){if(e===void 0){e=false}if(fakeData_1.isFakeAccountId(t)){return new Promise(function(e){return setTimeout(e,SIMULATED_DELAY_MS)}).then(function(){var e=fakeData_1.getFakeProfileCallouts(t);if(!e){throw new Error("No callouts")}return e})}var n=proto_1.impala.GetManagedProfileCalloutsRequest.encode({id:[t]});return this.makeRequest(this.config.accountServiceUrl+"/rpc/getManagedProfileCallouts",n).then(function(e){return proto_1.impala.GetManagedProfileCalloutsResponse.decode(e).callouts[0]})};e.prototype.getInsightsStoryManifest=function(e,t){var n=proto_1.impala.insights.GetStoryManifestRequest.encode({businessId:e,storyId:t});return this.makeRequest(this.config.insightsServiceUrl+"/insights/rpc/getBusinessStoryManifest",n).then(function(e){return proto_1.impala.insights.GetStoryManifestResponse.decode(e).manifest||null})};e.prototype.getStoryManifest=function(t,e,n){if(fakeData_1.isFakeAccountId(t)){return new Promise(function(e){return setTimeout(e,SIMULATED_DELAY_MS)}).then(function(){var e=fakeData_1.getFakeAccountData(t);if(!e||!e.storyManifest){throw new Error("No manifest")}return e.storyManifest})}var s=proto_1.impala.stories.GetBusinessStoryManifestRequest.encode({businessId:t,timeRange:e,includeInsights:n});return this.makeRequest(this.config.storyServiceUrl+"/rpc/getBusinessStoryManifest",s).then(function(e){return proto_1.impala.stories.GetBusinessStoryManifestResponse.decode(e).manifest||null})};e.prototype.getStoryManifests=function(t,e){if(fakeData_1.isFakeAccountId(t)){return new Promise(function(e){return setTimeout(e,SIMULATED_DELAY_MS)}).then(function(){var e=fakeData_1.getFakeAccountData(t);if(!e){throw new Error("No account data")}return proto_1.impala.stories.GetPastBusinessStoriesResponse.create({manifests:[e.storyManifest],nextPageId:null})})}var n=proto_1.impala.stories.GetPastBusinessStoriesRequest.encode({businessId:t,pageId:e,limit:15});return this.makeRequest(this.config.storyServiceUrl+"/rpc/getBusinessStoryManifest",n).then(function(e){return proto_1.impala.stories.GetPastBusinessStoriesResponse.decode(e)})};e.prototype.inviteUserToRole=function(e,t,n,s){if(fakeData_1.isFakeAccountId(e)){return new Promise(function(e){return setTimeout(e,SIMULATED_DELAY_MS)}).then(function(){return{autoApproved:false,roleAlreadyExists:false}})}var o=proto_1.impala.InviteUserToRoleRequest.encode({businessId:e,receivingUserId:t,invitingUserId:n,roleType:s});return this.makeRequest(this.config.accountServiceUrl+"/rpc/inviteUserToRole",o).then(function(e){return proto_1.impala.InviteUserToRoleResponse.decode(e)})};e.prototype.listNotifications=function(e,t){var n=proto_1.impala.ListNotificationsRequest.encode({businessId:e,pageId:t});return this.makeRequest(this.config.accountServiceUrl+"/rpc/listNotifications",n).then(function(e){return proto_1.impala.ListNotificationsResponse.decode(e)})};e.prototype.listRolesForBusiness=function(e){if(fakeData_1.isFakeAccountId(e)){return new Promise(function(e){return setTimeout(e,SIMULATED_DELAY_MS)}).then(function(){return[fakeData_1.roles.admin,fakeData_1.roles.collaborator]})}var t=proto_1.impala.ListRolesForBusinessRequest.encode({businessId:e});return this.makeRequest(this.config.accountServiceUrl+"/rpc/listRolesForBusiness",t).then(function(e){return proto_1.impala.ListRolesForBusinessResponse.decode(e).roles})};e.prototype.listPendingRoleInvitesForBusiness=function(e){if(fakeData_1.isFakeAccountId(e)){return new Promise(function(e){return setTimeout(e,SIMULATED_DELAY_MS)}).then(function(){return[fakeData_1.pendingRoleInvites.admin,fakeData_1.pendingRoleInvites.collaborator]})}var t=proto_1.impala.ListPendingRoleInvitesForBusinessRequest.encode({businessId:e});return this.makeRequest(this.config.accountServiceUrl+"/rpc/listPendingRoleInvitesForBusiness",t).then(function(e){return proto_1.impala.ListPendingRoleInvitesForBusinessResponse.decode(e).invites})};e.prototype.listPendingRoleInvitesForUser=function(){var e=proto_1.impala.ListPendingRoleInvitesForUserRequest.encode({});return this.makeRequest(this.config.accountServiceUrl+"/rpc/listPendingRoleInvitesForUser",e).then(function(e){return proto_1.impala.ListPendingRoleInvitesForUserResponse.decode(e).pendingProfiles})};e.prototype.updateRole=function(e,t,n,s){var o=proto_1.impala.UpdateRoleRequest.encode({businessId:e,userId:t,roleId:n,newRoleType:s});return this.makeRequest(this.config.accountServiceUrl+"/rpc/updateRole",o).then(function(e){return proto_1.impala.UpdateRoleResponse.decode(e)})};e.prototype.updateSubscribeStatus=function(e,t){if(fakeData_1.isFakeAccountId(e)){return new Promise(function(e){return setTimeout(e,SIMULATED_DELAY_MS)}).then(function(){return t})}var n=proto_1.impala.UpdateBusinessSubscribeStatusRequest.encode({businessId:e,subscribing:t});return this.makeRequest(this.config.accountServiceUrl+"/rpc/updateBusinessSubscribeStatus",n).then(function(){return t})};e.prototype.reportBusinessProfile=function(e){if(fakeData_1.isFakeAccountId(e)){return new Promise(function(e){return setTimeout(e,SIMULATED_DELAY_MS)}).then(function(){return proto_1.impala.ReportBusinessProfileResponse.create()})}var t="";var n=proto_1.impala.ReportBusinessProfileRequest.encode({businessId:e,reason:t});return this.makeRequest(this.config.accountServiceUrl+"rpc/reportBusinessProfile",n).then(function(e){return proto_1.impala.ReportBusinessProfileResponse.decode(e)})};e.prototype.updateBusinessProfile=function(e){if(fakeData_1.isFakeAccountId(e.id)){return new Promise(function(e){return setTimeout(e,SIMULATED_DELAY_MS)}).then(function(){return proto_1.impala.UpdateBusinessUserSettingsResponse.create()})}return this.makeRequest(this.config.accountServiceUrl+"/rpc/updateBusinessProfile",proto_1.impala.UpdateBusinessProfileRequest.encode(e)).then(function(e){return proto_1.impala.UpdateBusinessProfileResponse.decode(e)})};e.prototype.updateBusinessUserSettings=function(e){if(fakeData_1.isFakeAccountId(e.businessId)){return new Promise(function(e){return setTimeout(e,SIMULATED_DELAY_MS)}).then(function(){return proto_1.impala.UpdateBusinessUserSettingsResponse.create()})}return this.makeRequest(this.config.accountServiceUrl+"/rpc/updateBusinessUserSettings",proto_1.impala.UpdateBusinessUserSettingsRequest.encode(e)).then(function(e){return proto_1.impala.UpdateBusinessUserSettingsResponse.decode(e)})};e.prototype.makeFsnRequest=function(e,t){return RequestUtils.makeFsnJsonRequest(e,t)};e.prototype.makeFsnProtoRequest=function(e,t){return RequestUtils.makeFsnProtoRequest(e,t)};e.prototype.makeRequest=function(e,t){return RequestUtils.makeRequest(e,"POST","https://auth.snapchat.com/snap_token/api/business-accounts",t)};return e}();exports.default=Service;
